"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.XrpNodeStatus = void 0;
const StatusBase_1 = require("../StatusBase");
class XrpNodeStatus extends StatusBase_1.NodeStatusBase {
    get version() {
        var _a, _b, _c;
        return (_c = (_b = (_a = this.data) === null || _a === void 0 ? void 0 : _a.result) === null || _b === void 0 ? void 0 : _b.state) === null || _c === void 0 ? void 0 : _c.build_version;
    }
    /**
     * @docs https://xrpl.org/rippled-server-states.html
     */
    get state() {
        var _a, _b, _c;
        return (_c = (_b = (_a = this.data) === null || _a === void 0 ? void 0 : _a.result) === null || _b === void 0 ? void 0 : _b.state) === null || _c === void 0 ? void 0 : _c.server_state;
    }
    get isHealthy() {
        return ["connected", "syncing", "tracking", "full", "validating", "proposing"].includes(this.state);
    }
    get isSynced() {
        return ["full", "validating", "proposing"].includes(this.state);
    }
}
exports.XrpNodeStatus = XrpNodeStatus;
//# sourceMappingURL=XrpStatus.js.map