"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MCC = void 0;
const AlgoRpcImplementation_1 = require("./chain-clients/AlgoRpcImplementation");
const BtcRpcImplementation_1 = require("./chain-clients/BtcRpcImplementation");
const DogeRpcImplementation_1 = require("./chain-clients/DogeRpcImplementation");
const LtcRpcImplementation_1 = require("./chain-clients/LtcRpcImplementation");
const XrpRpcImplementation_1 = require("./chain-clients/XrpRpcImplementation");
const types_1 = require("./types");
var MCC;
(function (MCC) {
    class LTC extends LtcRpcImplementation_1.LTCImplementation {
        constructor(options) {
            super(options);
        }
    }
    MCC.LTC = LTC;
    class BTC extends BtcRpcImplementation_1.BTCImplementation {
        constructor(options) {
            super(options);
        }
    }
    MCC.BTC = BTC;
    class DOGE extends DogeRpcImplementation_1.DOGEImplementation {
        constructor(options) {
            super(options);
        }
    }
    MCC.DOGE = DOGE;
    class XRP extends XrpRpcImplementation_1.XRPImplementation {
        constructor(options) {
            super(options);
        }
    }
    MCC.XRP = XRP;
    class ALGO extends AlgoRpcImplementation_1.ALGOImplementation {
        constructor(options) {
            super(options);
        }
    }
    MCC.ALGO = ALGO;
    function getChainType(chainIdOrName) {
        if (chainIdOrName == null) {
            throw new Error("Chain missing");
        }
        switch (chainIdOrName) {
            case "XRP":
            case "RIPPLE":
            case types_1.ChainType.XRP:
                return types_1.ChainType.XRP;
            case "BTC":
            case types_1.ChainType.BTC:
                return types_1.ChainType.BTC;
            case "LTC":
            case types_1.ChainType.LTC:
                return types_1.ChainType.LTC;
            case "DOGE":
            case types_1.ChainType.DOGE:
                return types_1.ChainType.DOGE;
            case "ALGO":
            case "ALGORAND":
            case types_1.ChainType.ALGO:
                return types_1.ChainType.ALGO;
            default:
                return types_1.ChainType.invalid;
        }
    }
    MCC.getChainType = getChainType;
    function getChainTypeName(chainIdOrName) {
        if (chainIdOrName == null) {
            throw new Error("Chain missing");
        }
        switch (chainIdOrName) {
            case types_1.ChainType.XRP:
                return "XRP";
            case types_1.ChainType.BTC:
                return "BTC";
            case types_1.ChainType.LTC:
                return "LTC";
            case types_1.ChainType.DOGE:
                return "DOGE";
            case types_1.ChainType.ALGO:
                return "ALGO";
            default:
                return "invalid";
        }
    }
    MCC.getChainTypeName = getChainTypeName;
    function Client(chainIdOrName, options) {
        const chainType = getChainType(chainIdOrName);
        switch (chainType) {
            case types_1.ChainType.XRP:
                return new XRP(options);
            case types_1.ChainType.BTC:
                return new BTC(options);
            case types_1.ChainType.LTC:
                return new LTC(options);
            case types_1.ChainType.DOGE:
                return new DOGE(options);
            case types_1.ChainType.ALGO:
                return new ALGO(options);
            default: {
                throw new Error("Not implemented");
            }
        }
    }
    MCC.Client = Client;
})(MCC = exports.MCC || (exports.MCC = {}));
// Object exports
__exportStar(require("./base-objects/BlockBase"), exports);
__exportStar(require("./base-objects/StatusBase"), exports);
__exportStar(require("./base-objects/TransactionBase"), exports);
// Utils exports
__exportStar(require("./utils/utils"), exports);
__exportStar(require("./utils/algoUtils"), exports);
__exportStar(require("./utils/xrpUtils"), exports);
__exportStar(require("./utils/utxoUtils"), exports);
// Constants
__exportStar(require("./utils/constants"), exports);
// Type reflection
__exportStar(require("./utils/typeReflection"), exports);
// retry logic
__exportStar(require("./utils/retry"), exports);
// Types
__exportStar(require("./types"), exports);
//# sourceMappingURL=index.js.map