"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mccOutsideError = exports.mccError = exports.mccErrorCode = exports.MCC_ERROR = void 0;
exports.MCC_ERROR = "mccError";
var mccErrorCode;
(function (mccErrorCode) {
    mccErrorCode[mccErrorCode["InvalidParameter"] = 0] = "InvalidParameter";
    mccErrorCode[mccErrorCode["InvalidData"] = 1] = "InvalidData";
    mccErrorCode[mccErrorCode["InvalidBlock"] = 2] = "InvalidBlock";
    mccErrorCode[mccErrorCode["InvalidTransaction"] = 3] = "InvalidTransaction";
    mccErrorCode[mccErrorCode["InvalidResponse"] = 4] = "InvalidResponse";
    mccErrorCode[mccErrorCode["InvalidMethodCall"] = 5] = "InvalidMethodCall";
    mccErrorCode[mccErrorCode["OutsideError"] = 6] = "OutsideError";
})(mccErrorCode = exports.mccErrorCode || (exports.mccErrorCode = {}));
class mccError extends Error {
    constructor(errorCode, innerError) {
        super(mccErrorCode[errorCode]);
        this.name = exports.MCC_ERROR;
        this.errorCode = errorCode;
        this.innerError = innerError;
    }
}
exports.mccError = mccError;
class mccOutsideError extends mccError {
    constructor(innerError) {
        super(mccErrorCode.OutsideError, innerError);
    }
}
exports.mccOutsideError = mccOutsideError;
//# sourceMappingURL=errors.js.map