"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const src_1 = require("../../src");
const algoCreateConfig = {
    algod: {
        url: process.env.ALGO_ALGOD_URL || "",
        token: process.env.ALGO_ALGOD_TOKEN || "",
    },
};
describe("Algo Node Status tests (LIFE: expect healthy) ", function () {
    let MccClient;
    let status;
    before(function () {
        return __awaiter(this, void 0, void 0, function* () {
            MccClient = new src_1.MCC.ALGO(algoCreateConfig);
            const tStatus = yield MccClient.getNodeStatus();
            if (tStatus) {
                status = tStatus;
            }
        });
    });
    it("Should get status version ", function () {
        return __awaiter(this, void 0, void 0, function* () {
            const version = status.version.split("_");
            (0, chai_1.expect)(version[0]).to.be.eq("3");
        });
    });
    it.skip("Should get status state ", function () {
        return __awaiter(this, void 0, void 0, function* () {
            console.log(status.state);
        });
    });
    it("Should get status isHealthy ", function () {
        return __awaiter(this, void 0, void 0, function* () {
            // console.log(status.isHealthy);
            (0, chai_1.expect)(status.isHealthy).to.eq(true);
        });
    });
    it("Should get status isSynced ", function () {
        return __awaiter(this, void 0, void 0, function* () {
            // console.log(status.isSynced);
            (0, chai_1.expect)(status.isSynced).to.eq(true);
        });
    });
});
//# sourceMappingURL=status.test.js.map