"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = require("../../src/index");
const chai_1 = require("chai");
const reg_tests_url = process.env.DOGE_URL_REGTEST || "";
const reg_test_user = process.env.DOGE_USERNAME_REGTEST || "";
const reg_test_pass = process.env.DOGE_PASSWORD_REGTEST || "";
const ENABLE_REG_TEST = true;
describe("DOGE client tests", () => {
    describe("General functionalities", function () {
        it("should get block height from regtest network", function () {
            return __awaiter(this, void 0, void 0, function* () {
                const DogeRpc = new index_1.MCC.DOGE({ url: reg_tests_url, username: reg_test_user, password: reg_test_pass });
                let a = yield DogeRpc.getBlockHeight();
                (0, chai_1.expect)(a).to.greaterThan(100);
            });
        });
    });
    if (ENABLE_REG_TEST) {
        describe("Prove transaction on reg test node", function () {
            let DOGE_RPC;
            before(function () {
                DOGE_RPC = new index_1.MCC.DOGE({ url: reg_tests_url, username: reg_test_user, password: reg_test_pass });
            });
            it("should get transaction data", function () {
                var _a;
                return __awaiter(this, void 0, void 0, function* () {
                    // Note that this transaction may not exist if we reset the node
                    let tx = "242cd280ec9ce026900d18665b296c784f15ce22360296655bcdfedd55ffbec4";
                    let tx_data = yield DOGE_RPC.getTransaction(tx);
                    const tx_block_hash = "011b06ce85759bcd0ca7e9eb60d55b4e267686d26b8f00607ac8271c86f85e34";
                    (0, chai_1.expect)((_a = tx_data === null || tx_data === void 0 ? void 0 : tx_data.data) === null || _a === void 0 ? void 0 : _a.blockhash).to.equal(tx_block_hash);
                });
            });
        });
    }
});
//# sourceMappingURL=dogeClinet.test.js.map