"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = require("../../src/index");
const chai_1 = require("chai");
const public_url = "https://s1.ripple.com:51234";
const testnet_url = "https://s.altnet.rippletest.net:51234";
const devnet_url = "https://s.devnet.rippletest.net:51234";
describe("XRP ripple client tests", () => {
    it.skip("should be able to connect", () => { });
    it(`should get block height from public network`, function () {
        return __awaiter(this, void 0, void 0, function* () {
            const XRP = new index_1.MCC.XRP({ url: public_url });
            let a = yield XRP.getBlockHeight();
            (0, chai_1.expect)(a).to.greaterThan(68100602);
        });
    });
    it(`should get block height from testnet network`, function () {
        return __awaiter(this, void 0, void 0, function* () {
            const XRP = new index_1.MCC.XRP({ url: public_url });
            let a = yield XRP.getBlockHeight();
            (0, chai_1.expect)(a).to.greaterThan(0);
        });
    });
    it(`should get block height from devnet network`, function () {
        return __awaiter(this, void 0, void 0, function* () {
            const XRP = new index_1.MCC.XRP({ url: public_url });
            let a = yield XRP.getBlockHeight();
            (0, chai_1.expect)(a).to.greaterThan(0);
        });
    });
    describe(`Public XRP ripple client tests`, () => {
        it("should get tx data for existing tx", function () {
            return __awaiter(this, void 0, void 0, function* () {
                const XRP = new index_1.MCC.XRP({ url: public_url });
                const txhash = "D3F5C55522412EBE249061AC32E2390561B9511CEED4B173826B95E850F9947A";
                let res = yield XRP.getTransaction(txhash, { binary: false });
                console.log(res);
            });
        });
    });
});
//# sourceMappingURL=xrpClient.test.js.map