import { AccountInfoRequest, AccountTxRequest, LedgerResponse, TxResponse } from "xrpl";
import { RateLimitOptions } from "../types";
import { IIGetBlockRes, IIGetTransactionRes, MccLoggingOptions } from "./genericMccTypes";
export declare class XrpMccCreate {
    url: string;
    username?: string;
    password?: string;
    inRegTest?: boolean;
    rateLimitOptions?: RateLimitOptions | undefined;
    loggingOptions?: MccLoggingOptions | undefined;
}
export interface XrpCreateAddressData {
}
export interface IXrpGetTransactionRes extends IIGetTransactionRes, TxResponse {
}
export interface IXrpGetFullTransactionRes extends IXrpGetTransactionRes {
}
export interface IXrpGetBlockRes extends LedgerResponse, IIGetBlockRes {
}
export interface IXrpGetBlockHeaderRes extends LedgerResponse, IIGetBlockRes {
}
export declare type AccountRootFlags = "lsfDefaultRipple" | "lsfDepositAuth" | "lsfDisableMaster" | "lsfDisallowXRP" | "lsfGlobalFreeze" | "lsfNoFreeze" | "lsfPasswordSpent" | "lsfRequireAuth" | "lsfRequireDestTag";
export declare const FlagToHex: {
    lsfDepositAuth: number;
    lsfDefaultRipple: number;
    lsfGlobalFreeze: number;
    lsfNoFreeze: number;
    lsfDisableMaster: number;
    lsfDisallowXRP: number;
    lsfRequireAuth: number;
    lsfRequireDestTag: number;
    lsfPasswordSpent: number;
};
export declare const allHexFlags: number[];
export declare const HexToFlag: {
    16777216: string;
    8388608: string;
    4194304: string;
    2097152: string;
    1048576: string;
    524288: string;
    262144: string;
    131072: string;
    65536: string;
};
export declare const PosToFlag: {
    24: string;
    23: string;
    22: string;
    21: string;
    20: string;
    19: string;
    18: string;
    17: string;
    16: string;
};
export declare const SpecialAddressesReverse: {
    rrrrrrrrrrrrrrrrrrrrrhoLvTp: string;
    rrrrrrrrrrrrrrrrrrrrBZbvji: string;
    rHb9CJAWyB4rj91VRWn96DkukG4bwdtyTh: string;
    rrrrrrrrrrrrrrrrrNAMEtxvNvQ: string;
    rrrrrrrrrrrrrrrrrrrn5RM1rHd: string;
};
export declare const SpecialAddresses: {
    ACCOUNT_ZERO: string;
    ACCOUNT_ONE: string;
    GENESIS_ACCOUNT: string;
    RESERVATION_BLACK_HOLE: string;
    NaN_ADDRESS: string;
};
export declare type IAccountInfoRequest = Omit<AccountInfoRequest, "command">;
export declare type IAccountTxRequest = Omit<AccountTxRequest, "command">;
//# sourceMappingURL=xrpTypes.d.ts.map